<template>
  <div ref="div" style="position: relative;">
    <canvas
      ref="canvas"
      id="matrix1"
      :width="width"
      :height="height"
      style="position: absolute;"
    />
    <canvas
      ref="selection_canvas"
      id="matrix2"
      :width="width"
      :height="height"
      style="position: absolute;"
    />
  </div>
</template>

<script>
import * as d3 from "d3";
import lasso from "@/util/lasso";

export default {
  props: {
    width: {
      type: Number,
      required: true
    },
    height: {
      type: Number,
      required: true
    },
    data: Object,
    dark: Boolean,
    selectedNodes: Array,
    zoomSelectionNodes: Array,
    isZoomed: Boolean
  },

  data() {
    return {
      canvas: null,
      context: null,
      selectionCanvas: null,
      selectionContext: null,
      selectedPoints: [],
      cacheVertices: [],
      cacheEdges: [],
      selectedColumns: [],
      lassoInstance: null,
      min: Number.MAX_VALUE,
      max: Number.MIN_VALUE,
      squares: [],
      updating: false,
      clickedEdge: null,
      firstClick: true
    };
  },

  watch: {
    dark: function() {
      this.tick();
    },
    width: function() {
      this.tick();
    },
    height: function() {
      this.tick();
    },
    data: function() {
      this.tick();
    },
    selectedNodes: function() {
      this.tick();
    },
    isZoomed: function() {
      this.setSquares();
      this.draw();
      this.tick();
    }
  },

  computed: {
    edges() {
      if (this.zoomSelectionNodes.length == 0) {
        return this.data ? this.data.matrix.edges : [];
      } else {
        let e = [];
        this.zoomSelectionNodes.forEach(d => {
          let n = [];
          this.zoomSelectionNodes.forEach(z => {
            n.push(this.data.matrix.edges[d][z]);
          });
          e.push(n);
        });

        return e;
      }
    },
    vertices() {
      if (this.zoomSelectionNodes.length == 0) {
        return this.data
          ? this.data.graph.nodes.map(d => {
              return d.id;
            })
          : [];
      } else {
        return this.zoomSelectionNodes;
      }
    },
    nrows() {
      return this.edges.length;
    },
    startPosition() {
      const x = (this.width - this.cellsize * this.nrows) / 2;
      const y = (this.height - this.cellsize * this.nrows) / 2;
      return { x, y };
    },
    cellsize() {
      const width = this.width / this.nrows;
      const height = this.height / this.nrows;
      return width > height ? height : width;
    }
  },

  methods: {
    draw() {
      this.context.save();

      this.context.clearRect(0, 0, this.canvas.width, this.canvas.height);
      this.squares.forEach(s => {
        this.context.fillStyle = s[2];
        this.context.beginPath();
        this.context.fillRect(s[0], s[1], this.cellsize, this.cellsize);
      });

      this.context.restore();
    },
    tick() {
      this.selectionContext.save();
      this.selectionContext.clearRect(
        0,
        0,
        this.canvas.width,
        this.canvas.height
      );

      this.squares.forEach(s => {
        this.selectionContext.fillStyle = "rgba(0, 0, 0, 0.5)";
        this.selectionContext.beginPath();
        if (
          this.selectedNodes.includes(s[3]) ||
          this.selectedNodes.includes(s[4])
        ) {
          this.selectionContext.fillRect(
            s[0],
            s[1],
            this.cellsize,
            this.cellsize
          );
        }
      });

      // Looks if the text of the clicked node fits inside the canvas element
      // Then calls drawText
      if (this.clickedEdge != null) {
        let text =
          "value: " +
          this.clickedEdge.value +
          "  source: " +
          this.clickedEdge.source +
          "  target: " +
          this.clickedEdge.target;

        let rectWidth = text.length * 7;
        let rectHeight = 20;

        if (this.clickedEdge.mouseX + rectWidth <= this.canvas.width) {
          this.drawText(
            this.clickedEdge.mouseX,
            this.clickedEdge.mouseY,
            rectWidth,
            rectHeight,
            text
          );
        } else if (this.clickedEdge.mouseX + rectWidth > this.canvas.width) {
          this.drawText(
            this.clickedEdge.mouseX - rectWidth,
            this.clickedEdge.mouseY,
            rectWidth,
            rectHeight,
            text
          );
        }
      }

      this.selectionContext.restore();
    },
    setSquares() {
      let rowLength = this.vertices.length;
      //loop over all rows
      for (let i = 0; i < rowLength; i++) {
        let row = this.edges[i];

        //loop over all row elements
        for (let j = 0; j < rowLength; j++) {
          let edge = row[j];

          //if edge larger than max then it is the new maximum,
          //else if it is smaller than min it is the new minimum
          if (edge > this.max) {
            this.max = edge;
          } else if (edge < this.min) {
            this.min = edge;
          }
        }
      }
      this.squares = [];
      //use d3 to crate a color gradient
      const color = d3
        .scaleLinear()
        .range(["#66ccff", "#ff0000"])
        .domain([this.min, this.max]);
      // draw squares
      for (let i = 0; i < rowLength; i++) {
        for (let j = 0; j < rowLength; j++) {
          let colorSquare = color(this.edges[i][j]);
          let squareData = [
            this.startPosition.x + j * this.cellsize,
            this.startPosition.y + i * this.cellsize,
            colorSquare,
            this.vertices[i],
            this.vertices[j]
          ];
          this.squares.push(squareData);
        }
      }
    },
    handleLassoStart() {
      this.selectionContext.save();
      this.selectionContext.clearRect(
        0,
        0,
        this.canvas.width,
        this.canvas.height
      );
      this.context.restore();
      this.tick();
    },
    handleLassoEnd(lassoPolygon) {
      this.squares.forEach(s => {
        if (d3.polygonContains(lassoPolygon, [s[0], s[1]])) {
          if (!this.selectedNodes.includes(s[3])) {
            this.$store.commit("addSelectedNode", s[3]);
          }
          if (!this.selectedNodes.includes(s[4])) {
            this.$store.commit("addSelectedNode", s[4]);
          }
        }
      });

      this.tick();
    },
    // Handels when a edge is clicked
    clicked() {
      this.clickedEdge = null;
      let mouseCoor = d3.mouse(d3.event.currentTarget);
      let mouseX = mouseCoor[0];
      let mouseY = mouseCoor[1];

      var rowLength = this.vertices.length;

      for (let i = 0; i < rowLength; i++) {
        for (let j = 0; j < rowLength; j++) {
          if (
            mouseX >= this.startPosition.x + j * this.cellsize &&
            mouseX < this.startPosition.x + (j + 1) * this.cellsize &&
            mouseY >= this.startPosition.y + i * this.cellsize &&
            mouseY < this.startPosition.y + (i + 1) * this.cellsize
          ) {
            this.clickedEdge = {
              value: this.edges[i][j],
              x: j,
              y: i,
              mouseX: mouseX,
              mouseY: mouseY,
              source: this.data.graph.nodes.filter(d => {
                if (d.id == this.vertices[i]) return true;
                else return false;
              })[0].name,
              target: this.data.graph.nodes.filter(d => {
                if (d.id == this.vertices[j]) return true;
                else return false;
              })[0].name
            };

            if (
              !this.selectedNodes.includes(this.vertices[this.clickedEdge.x])
            ) {
              console.log(this.vertices[this.clickedEdge.x]);
              this.$store.commit(
                "addSelectedNode",
                this.vertices[this.clickedEdge.x]
              );
            }
            if (
              !this.selectedNodes.includes(this.vertices[this.clickedEdge.y])
            ) {
              this.$store.commit(
                "addSelectedNode",
                this.vertices[this.clickedEdge.y]
              );
            }
          }
        }
      }
      this.tick();
    },
    // Draws the text that shows the value, source and target of a edge
    drawText(x, y, rectWidth, rectHeight, text) {
      this.selectionContext.beginPath();
      this.selectionContext.fillStyle = "black";

      this.selectionContext.rect(
        x - 2,
        y - rectHeight - 2,
        rectWidth + 4,
        rectHeight + 4
      );
      this.selectionContext.fill();

      this.selectionContext.beginPath();
      this.selectionContext.fillStyle = "white";
      this.selectionContext.rect(x, y - rectHeight, rectWidth, rectHeight);
      this.selectionContext.fill();
      this.selectionContext.beginPath();
      this.selectionContext.font = "15px Arial";
      this.selectionContext.textAlign = "left";
      this.selectionContext.textBaseline = "white";

      this.selectionContext.fillStyle = "black";
      this.selectionContext.fillText(text.replace(/_/g, " "), x, y - 3);
    }
  },

  async mounted() {
    this.canvas = this.$refs["canvas"];
    this.context = this.canvas.getContext("2d");

    this.selectionCanvas = this.$refs["selection_canvas"];
    this.selectionCanvas.addEventListener(
      "click",
      () => {
        this.selectedColumns = [];
        this.tick();
      },
      false
    );
    this.selectionContext = this.selectionCanvas.getContext("2d");

    // Create listener to look if a node is clicked
    this.selection = d3.select(this.selectionCanvas).on("click", () => {
      if (this.firstClick == true) {
        this.clicked();
        this.firstClick = false;
      } else {
        this.firstClick = true;
        this.clickedEdge = null;
        this.tick();
      }
    });

    this.lassoInstance = await lasso("#F00", true);
    this.lassoInstance
      .on("start", this.handleLassoStart)
      .on("end", this.handleLassoEnd);

    // create key listeners for selection option
    let scope = this;
    window.addEventListener("keydown", e => {
      if (e.keyCode == 16) {
        try {
          d3.select(scope.$refs["div"])
            .append("svg")
            .style("position", "absolute")
            .style("top", 0)
            .style("left", 0)
            .attr("width", scope.canvas.width)
            .attr("height", scope.canvas.height);
          d3.select(scope.$refs["div"])
            .select("svg")
            .call(scope.lassoInstance);
        } catch (exception) {
          // wait until element is loaded
        }
      }
    });

    window.addEventListener("keyup", e => {
      if (e.keyCode == 16) {
        d3.select(scope.$refs["div"])
          .selectAll("svg")
          .remove();
      }
    });

    this.setSquares();
    this.draw();
  },

  updated() {
    this.updating = true;
    this.setSquares();
    this.draw();
    this.tick();
    setTimeout(() => {
      this.updating = false;
    }, 1000);
  }
};
</script>
